

MAKE(CPM)							MAKE(CPM)

	
	SYNTAX

		make [filename] [-f makefilename] [-i] [-n]

	WHERE

		-i means continue even if an error is encountered

		-n means don't execute the commands, just write the ones that
		   would be executed to the standard output. 

		-f specifies that the following argument is the name of
		   a makefile to be used instead of default "MAKEFILE.DAT".

	DESCRIPTION

		This program is a very simple clone of the UNIX
		(tm of AT&T) utility of the same name.  Dependancy
		information is extracted from a makefile and acted upon.

		This version requires CP/M-80 version 3.0 ("CP/M PLUS")
		with time-of-day-clock implemented.  Also the file timestamps
		must be "turned on".

	MAKEFILE FORMAT

	        "Make" without parameters makes the first target in the
		makefile.

		The default name of the 'makefile' is 'MAKEFILE.DAT'.
		If the '-f' option is used, the default makefile
		is not processed.
	
		Any blank lines in the 'makefile(s)' are ignored, as are
		lines that have a "#" in the first column.
	
	 	Lines starting with a tab or space character are 'howto'
		lines, and consist of a command name followed by arguments.

		Any other line is a 'dependency' line.  'Dependency'
		lines consist of a filename followed by a (possibly empty)
		list of dependent filenames.  A colon is allowed after
		the target filename.
	        
	
	 	'Howto' lines apply to the most	recently preceding 
		'dependency' line.  It is improper for 	a 'howto' line
		 to precede the first 'dependency' line.

	NITTY GRITTY MAKEFILE INFO

		All arguments may be repeated, and relative position of
		the arguments is not important.  If multiple definitions
		of a file are found, only the first one is significant.




MAKE(CPM)			-2-				MAKE(CPM)

	

		First, 'Make' reads all of the makefiles.  It then proceeds
		through	all of the filename arguments, 'making' each one in
		turn.  A file is remade if it is out of date with respect to
		the files it depends on or is non-existent. Dependencies are
		processed in a 'tree' fashion, so that the lowest-order 
		files are remade first.

	SIDE EFFECTS

		This program works by producing a temporary file "MAKE@@@.SUB"
		then chaining to it for execution of the command list.  This
		file then deletes itself upon successful completion.  Should
		the execution be aborted, then this file will remain existant
		in the file system (but will not harm later invocations of
		make).

	AUTHOR

	Copyright 1984 and
	Written by John M Sellens, April, 1984 	(for MS-DOS w/DeSmet Compiler)
		c/o 1135 Lansdowne Ave. SW			      (IBM PC)
		Calgary, Alberta
		T2S 1A4

						
	Modified by Guido van Rossum, 		(for MS-DOS w/Lattice Compiler)
	        Copyright (c) Stichting Mathematisch Centrum, 	       (IBM PC)
		Amsterdam, 1984. 

	Modified by Michael D. Kersenbrock	(for CP/M 3.0 w/Aztec Compiler)
		Copyright (c) 1985				       (Z80A)

